Uses Crt, Strings, WinDos;

Procedure BHex(s: PChar; b: Byte);
Const HC: Array[0..15]Of Char = '0123456789ABCDEF';
Begin
	s[0] := HC[b Shr 4];
	s[1] := HC[b And 15];
	s[2] := #0
End;

Procedure WHex(s: PChar; w: Word);
Begin
	BHex(s+0, WordRec(w).Hi);
	BHex(s+2, WordRec(w).Lo)
End;

Procedure LHex(s: PChar; l: LongInt);
Begin
	WHex(s+0, LongRec(l).Hi);
	WHex(s+4, LongRec(l).Lo);
End;

Var
	Counter:  LongInt;

Const
	Ac=0; Zx=5; Ix=10;
	Il=1; Zy=6; Iy=11;
	Im=2; Ax=7;_In=12;
	Ab=3; Ay=8; No=13;
	Zp=4; Rl=9;
	(* These are the addressation methods used by 6502 CPU. *)

Function DAsm(S: PChar; A: PByte; PC: LongInt): Integer; Forward;
(* This function will disassemble a single command and *)
(* return the number of bytes disassembled.            *)

Const MN: Array[0..8*7-1]Of PChar =
(
	'adc','and','asl','bcc','bcs','beq','bit','bmi',
	'bne','bpl','brk','bvc','bvs','clc','cld','cli',
	'clv','cmp','cpx','cpy','dec','dex','dey','inx',
	'iny','eor','inc','jmp','jsr','lda','nop','ldx',
	'ldy','lsr','ora','pha','php','pla','plp','rol',
	'ror','rti','rts','sbc','sta','stx','sty','sec',
	'sed','sei','tax','tay','txa','tya','tsx','txs'
);

Const
	AD: Array[0..511]Of Byte =
(
	10,Il, 34,Ix, No,No, No,No, No,No, 34,Zp,  2,Zp, No,No,
	36,Il, 34,Im,  2,Ac, No,No, No,No, 34,Ab,  2,Ab, No,No,
	 9,Rl, 34,Iy, No,No, No,No, No,No, 34,Zx,  2,Zx, No,No,
	13,Il, 34,Ay, No,No, No,No, No,No, 34,Ax,  2,Ax, No,No,
	28,Ab,  1,Ix, No,No, No,No,  6,Zp,  1,Zp, 39,Zp, No,No,
	38,Il,  1,Im, 39,Ac, No,No,  6,Ab,  1,Ab, 39,Ab, No,No,
	 7,Rl,  1,Iy, No,No, No,No, No,No,  1,Zx, 39,Zx, No,No,
	47,Il,  1,Ay, No,No, No,No, No,No,  1,Ax, 39,Ax, No,No,
	41,Il, 25,Ix, No,No, No,No, No,No, 25,Zp, 33,Zp, No,No,
	35,Il, 25,Im, 33,Ac, No,No, 27,Ab, 25,Ab, 33,Ab, No,No,
	11,Rl, 25,Iy, No,No, No,No, No,No, 25,Zx, 33,Zx, No,No,
	15,Il, 25,Ay, No,No, No,No, No,No, 25,Ax, 33,Ax, No,No,
	42,Il,  0,Ix, No,No, No,No, No,No,  0,Zp, 40,Zp, No,No,
	37,Il,  0,Im, 40,Ac, No,No, 27,_In, 0,Ab, 40,Ab, No,No,
	12,Rl,  0,Iy, No,No, No,No, No,No,  0,Zx, 40,Zx, No,No,
	49,Il,  0,Ay, No,No, No,No, No,No,  0,Ax, 40,Ax, No,No,
	No,No, 44,Ix, No,No, No,No, 46,Zp, 44,Zp, 45,Zp, No,No,
	22,Il, No,No, 52,Il, No,No, 46,Ab, 44,Ab, 45,Ab, No,No,
	 3,Rl, 44,Iy, No,No, No,No, 46,Zx, 44,Zx, 45,Zy, No,No,
	53,Il, 44,Ay, 55,Il, No,No, No,No, 44,Ax, No,No, No,No,
	32,Im, 29,Ix, 31,Im, No,No, 32,Zp, 29,Zp, 31,Zp, No,No,
	51,Il, 29,Im, 50,Il, No,No, 32,Ab, 29,Ab, 31,Ab, No,No,
	 4,Rl, 29,Iy, No,No, No,No, 32,Zx, 29,Zx, 31,Zy, No,No,
	16,Il, 29,Ay, 54,Il, No,No, 32,Ax, 29,Ax, 31,Ay, No,No,
	19,Im, 17,Ix, No,No, No,No, 19,Zp, 17,Zp, 20,Zp, No,No,
	24,Il, 17,Im, 21,Il, No,No, 19,Ab, 17,Ab, 20,Ab, No,No,
	 8,Rl, 17,Iy, No,No, No,No, No,No, 17,Zx, 20,Zx, No,No,
	14,Il, 17,Ay, No,No, No,No, No,No, 17,Ax, 20,Ax, No,No,
	18,Im, 43,Ix, No,No, No,No, 18,Zp, 43,Zp, 26,Zp, No,No,
	23,Il, 43,Im, 30,Il, No,No, 18,Ab, 43,Ab, 26,Ab, No,No,
	 5,Rl, 43,Iy, No,No, No,No, No,No, 43,Zx, 26,Zx, No,No,
	48,Il, 43,Ay, No,No, No,No, No,No, 43,Ax, 26,Ax, No,No
);

(** DAsm() ****************************************************)
(** This function will disassemble a single command and      **)
(** return the number of bytes disassembled.                 **)
(**************************************************************)
Function DAsm(S: PChar; A: PByte; PC: LongInt): Integer;
Var
	w: Word;
	B: PByte;
	J: Byte;
	OP: Integer;
Begin
	B := A;
	OP := (B^)*2; Inc(B);

	strcpy(s, MN[AD[OP]]);

	Case AD[OP+1]Of
		Ac: strcat(s, ' a');
		Il: ;
		Rl:
		Begin
			J := B^; Inc(B);
			Inc(PC, 2);
			If J<$80 Then Inc(PC, J)Else Inc(PC, J-256);
			strcat(s, ' ');
			LHex(strend(s), PC)
		End;
		Im:
		Begin
			strcat(s, ' #');
			BHex(strend(s), B^);
			Inc(B)
		End;
		Zp:
		Begin
			strcat(s, ' ');
			BHex(strend(s), B^);
			Inc(B)
		End;
		Zx:
		Begin
			strcat(s, ' ');
			BHex(strend(s), B^);
			strcat(s, ',x');
			Inc(B)
		End;
		Zy:
		Begin
			strcat(s, ' ');
			BHex(strend(s), B^);
			strcat(s, ',y');
			Inc(B)
		End;
		Ix:
		Begin
			strcat(s, ' (');
			BHex(strend(s), B^);
			strcat(s, ',x)');
			Inc(B)
		End;
		Iy:
		Begin
			strcat(s, ' (');
			BHex(strend(s), B^);
			strcat(s, '),y');
			Inc(B)
		End;
		Ab:
		Begin
			w :=           B^; Inc(B);
			w := w Shl 8 + B^; Inc(B);
			strcat(s, ' ');
			WHex(strend(s), w)
		End;
		Ax:
		Begin
			w :=           B^; Inc(B);
			w := w Shl 8 + B^; Inc(B);
			strcat(s, ' ');
			WHex(strend(s), w);
			strcat(s, ',x')
		End;
		Ay:
		Begin
			w :=           B^; Inc(B);
			w := w Shl 8 + B^; Inc(B);
			strcat(s, ' ');
			WHex(strend(s), w);
			strcat(s, ',y')
		End;
		_In:
		Begin
			w :=           B^; Inc(B);
			w := w Shl 8 + B^; Inc(B);
			strcat(s, ' (');
			WHex(strend(s), w);
			strcat(s, ')')
		End;
		Else
		Begin
			strcpy(s, '.db ');
			BHex(strend(s), OP Shr 1)
		End;
	End;
	DAsm := PChar(B) - PChar(A)
End;

Var
	F: File;
	N,I,J: Integer;
	Buf: Array[0..31]Of Char;
	Buf2:Array[0..31]Of Char;
	S:   Array[0..127]Of Char;
Begin
	ClrScr;
	DirectVideo := False;

	J := 0;
	Counter := 0;

	GetArgStr(S, 1, 127);
	Assign(F, S);
	Reset(f, 1);
	If IOResult <> 0 Then
	Begin
		WriteLn('Can''t open file ',S);
		Exit
	End;

	N := 0;
	Repeat
		BlockRead(F, Buf[N], 16-N, I);
		Inc(N, I);
		If N=0 Then Break;
		FillChar(Buf[N], 32-N, 0);
		I := DAsm(S, PByte(@Buf), Counter);
		LHex(Buf2, Counter);
		Write(Buf2,':');

		For J := 0 To I-1 Do
		Begin
			Write(' ');
			BHex(Buf2, Ord(Buf[J]));
			Write(Buf2);
		End;
		If I<3 Then Write(#9);

		WriteLn(#9,S);
		Inc(Counter, I);
		Dec(N, I);
		If N>0 Then
			For J := 0 To N-1 Do
				Buf[J] := Buf[16-N+J]
		Else
			If N<0 Then N := 0
	Until False;

	Close(F);
End.
